using System;
using System.Data;
using System.Configuration;
using System.Web.Configuration;
using System.Web.Security;
using System.Web.UI;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using FTPAttachmentV20;
using FTPAttachments;
/// <summary>
/// Summary description for FTPService
/// </summary>
public class FTPService
{
   
	public FTPService()
	{
		//
		// TODO: Add constructor logic here
		//
		
	}
	//public FTPAttachmentsWebService10 m_WebService10;
	//public FTPAttachmentsWebService10 WebService10
	//{
	//    get { return m_WebService10; }		
	//}


	public static FTPAttachmentsWebService10 GetServiceFromSession(HttpRequest Request)
	{
		FTPAttachmentsWebService10 WebService10 = new FTPAttachmentsWebService10();
		if(WebService10 != null)
		{
			string strUrl = WebConfigurationManager.AppSettings["APIUrl"];
			if(strUrl == null)
				return null;
						
			//Create and initialize WebServiceHeader.
			WebService10.WebServiceHeaderValue = new FTPAttachments.WebServiceHeader();
			WebService10.Url = strUrl;
			if (Request.Params["SFUrl"] != null && Request.Params["SFUrl"].Length > 0 && Request.Params["SFSessionID"] != null && Request.Params["SFSessionID"].Length > 0)
			{
				WebService10.WebServiceHeaderValue.SFSessionID = Request.Params["SFSessionID"];
				WebService10.WebServiceHeaderValue.SFUrl = Request.Params["SFUrl"];				
			}		
		}
		return WebService10;
	}

    public static FTPAttachmentV20.FTPAttachments CreateFTPAttachmentsV20(HttpContext context)
    {
        if (context == null)
            throw new Exception(Resources.Messages.NoContext);

        HttpRequest Request = context.Request;
        
        FTPAttachmentV20.FTPAttachments attachment = new FTPAttachmentV20.FTPAttachments();
        FTPAttachmentV20.FTPAttachmentParent parent = new FTPAttachmentV20.FTPAttachmentParent();
        parent.FieldName = Request["FieldName"];
        parent.ID = Request["FieldValue"];
        attachment.Parents = new FTPAttachmentV20.FTPAttachmentParent[] { parent };
        attachment.Folder = Request["Folder"];
        attachment.SSPUser = Request.Params["SSPUser"];
        attachment.IsSelfServicePortal = Request["SelfServicePortal"] == "true" ? true :false;
        attachment.ServerProfile = Request["ServerProfile"];
        return attachment;
    }

    public static string CheckRequiredFields(HttpContext Context, string[] arrRequiredFields, params string[] arrExtraFields)
    {
        string strMissingFields = "";
        if (arrRequiredFields != null)
        {
            string strValue = null;
            foreach (string strField in arrRequiredFields)
            {
                strValue = Context.Request.Params[strField];
                if (strValue == null || strValue.Length == 0)
                {
                    if (strField == "SFUrl" || strField == "SFSessionID")
                    {
                        strValue = Context.Request.Params["SSPParams"];
                        if (strValue != null && strValue.Length > 0)
                            continue;
                    }
                    if (Context.Session[strField] == null || ((string)Context.Session[strField]).Length <= 0)
                        strMissingFields += strField + ",";
                }
            }
        }

        if (arrExtraFields != null)
        {
            foreach (string strField in arrExtraFields)
            {
                string strValue = Context.Request.Params[strField];
                if (strValue == null || strValue.Length == 0)
                    if (Context.Session[strField] == null || ((string)Context.Session[strField]).Length <= 0)
                        strMissingFields += strField + ",";
            }
        }

        if (strMissingFields == string.Empty)
            return null;
        else
            return string.Format(Resources.Messages.FieldsMissingInUrl, strMissingFields.TrimEnd(','));
    }


    public static enzigma.net.storage.IProfile GetProfile(ServerProfile serverProfile)
    {
        enzigma.net.storage.IProfile resProfile = null;
        if (serverProfile != null)
        {
            switch (serverProfile.StorageType)
            {
                case StorageType.AmazonS3:
                    resProfile = new enzigma.net.storage.AmazonS3Profile();
                    break;
                case StorageType.FTP:
                    enzigma.net.storage.FTPProfile ftpProfile = new enzigma.net.storage.FTPProfile();
                    ftpProfile.Passive = serverProfile.Passive;
                    ftpProfile.Encryptdata = serverProfile.EncryptData;
                    resProfile = ftpProfile;
                    break;
                case StorageType.Local:
                    resProfile = new enzigma.net.storage.LocalProfile();
                    break;
                case StorageType.FTPS:
                    enzigma.net.storage.FTPSProfile ftpsProfile = new enzigma.net.storage.FTPSProfile();
                    ftpsProfile.AuthSsl = serverProfile.AuthTLS;
                    ftpsProfile.Passive = serverProfile.Passive;
                    ftpsProfile.Ssl = serverProfile.SSL;
                    ftpsProfile.TimeOut = 1 * 60 * 1000;
                    resProfile = ftpsProfile;
                    break;
                case StorageType.SFTP:
                    resProfile = new enzigma.net.storage.SFTPProfile();
                    break;
            }
            resProfile.DefaultFolder = serverProfile.DefaultFolder;
            resProfile.SetCredentials(serverProfile.Server, serverProfile.Port, serverProfile.Login, serverProfile.Password);
        }
        return resProfile;
    }
}
