using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Text;

using FTPAttachments;

public partial class DownloadLatest : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e){ }

	protected void btnDownload_Click(object sender, EventArgs e)
	{
		if (edAttachmentID.Text != "")
		{
			FTPAttachmentsWebService10 WebService10 = FTPService.GetServiceFromSession(Request);
			if (WebService10 != null)
			{
				//Download FTPAttachments Latest version by their IDs.
				string[] arrIDs = (edAttachmentID.Text).Split(',');
				Result[] m_arrResult = WebService10.DownloadLatest(arrIDs);

				//Check the result of Download.
				string strPhysicalPath = Request.PhysicalApplicationPath;
				if (m_arrResult != null && m_arrResult.Length > 0)
				{
					string strTempPath = strPhysicalPath + "App_Data\\Temp\\";
					if(!Directory.Exists(strTempPath))
					{
						Directory.CreateDirectory(strTempPath);
					}
					//Download all files to the App_Data\\Temp of application.
					for (int iIndex = 0; iIndex < m_arrResult.Length; iIndex++)
					{
						//lbError.Text += "<br>" + m_arrResult[iIndex].ErrorMsg;
						if (m_arrResult[iIndex].ErrorCode == ErrorCode.Success)
						{
							lbError.Text = "Download Complete sucessfully." + "<BR>";
							if (m_arrResult[iIndex].FTPAttachments.Body != null || m_arrResult[iIndex].FTPAttachments.Body != "")
							{
								byte[] arrFileContents = System.Convert.FromBase64String(m_arrResult[iIndex].FTPAttachments.Body);
								string strFullPath = strPhysicalPath + "App_Data\\Temp\\" + m_arrResult[iIndex].FTPAttachments.FileName;
								File.WriteAllBytes(strFullPath, arrFileContents);
							}							
						}
						else
							lbError.Text += "Download Failed for " + m_arrResult[iIndex].FTPAttachments.FileName + " " + m_arrResult[iIndex].ErrorMsg + "<br>";
					}
					#region popup
					//Display a pop up window if single attachment is downloaded.
					if (m_arrResult.Length == 1 && m_arrResult[0].ErrorCode == ErrorCode.Success)
					{
						lbError.Text = "Download Complete.";	
						string strLocalFile = strPhysicalPath + "App_Data\\Temp\\" + m_arrResult[0].FTPAttachments.FileName;
						//string strLocalFile = strPath + m_arrResult[0].FTPAttachments.FileName;
						FileInfo fileInfo = new FileInfo(strLocalFile);
						long lLen = fileInfo.Length;
						Response.ContentType = "application/octet-stream";
						if (Request.UserAgent.ToLower().IndexOf("firefox") >= 0)
							Response.AddHeader("Content-Disposition", "attachment; filename=" + HttpUtility.UrlEncode(m_arrResult[0].FTPAttachments.FileName));
						else
							Response.AddHeader("Content-Disposition", "attachment; filename=" + m_arrResult[0].FTPAttachments.FileName);
						Response.AddHeader("Content-Length", lLen.ToString());
						Response.WriteFile(strLocalFile);
						try { Response.Flush(); }
						catch (Exception) { }
						Response.Close();
					}
					#endregion
				}	
			}
			else
				lbError.Text = "Service not found.";
		}
		else
			lbError.Text = "Please enter comma separated list of Attachment ID's for files to be downloaded";
	}
}
