using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

using FTPAttachments;

public partial class DownloadVersion : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e){}

	protected void btnDownload_Click(object sender, EventArgs e)
	{
		if (edAttachmentID.Text != null && edAttachmentID.Text != "")
		{
			FTPAttachmentsWebService10 WebService10 = FTPService.GetServiceFromSession(Request);
			if (WebService10 != null)
			{				
				string[] arrIDs = (edAttachmentID.Text).Split(',');
				string[] arrVersions = (edVersion.Text).Split(',');

				//Create and Fill data into array of FTPAttachments.
				FTPAttachments.FTPAttachments[] arrFTPAttachments = new FTPAttachments.FTPAttachments[arrIDs.Length];
				for (int iIndex = 0; iIndex < arrFTPAttachments.Length; iIndex++)
				{
					arrFTPAttachments[iIndex] = new FTPAttachments.FTPAttachments();
					arrFTPAttachments[iIndex].AttachmentID = arrIDs[iIndex];
					
					//If for some attachemnts version is not specified 1 will be assumed as a version to be downloaded.
					if (arrVersions != null && arrVersions.Length > 0)
					{
						try { arrFTPAttachments[iIndex].Version = int.Parse(arrVersions[iIndex]); }
						catch (Exception) { arrFTPAttachments[iIndex].Version = 1; }
					}
					else
						arrFTPAttachments[iIndex].Version = 1;
				}

				//Download FTPAttachments with specified version.
				Result[] m_arrResult = WebService10.DownloadVersions(arrFTPAttachments);

				////Check the whether Download was sucessful or not.
				string strPhysicalPath = Request.PhysicalApplicationPath;
				string strPath = "";
				if (m_arrResult != null && m_arrResult.Length > 0)
				{
					string strTempPath = strPhysicalPath + "App_Data\\Temp\\";
					if (!Directory.Exists(strTempPath))
					{
						Directory.CreateDirectory(strTempPath);
					}
					for (int iIndex = 0; iIndex < m_arrResult.Length; iIndex++)
					{
						if (m_arrResult[iIndex].ErrorCode == ErrorCode.Success)
						{
							lbError.Text += "Download Complete sucessfully." + "<br>";	
							if (m_arrResult[iIndex].FTPAttachments.Body != null || m_arrResult[iIndex].FTPAttachments.Body != "")
							{
								byte[] arrFileContents = System.Convert.FromBase64String(m_arrResult[iIndex].FTPAttachments.Body);
								strPath = strPhysicalPath + "App_Data\\Temp\\" + m_arrResult[iIndex].FTPAttachments.FileName;
								File.WriteAllBytes(strPath, arrFileContents);
							}
						}
						else
							lbError.Text += "Download Failed for" + m_arrResult[iIndex].FTPAttachments.FileName + " " + m_arrResult[iIndex].ErrorMsg + "<br>";
					}
					if (m_arrResult.Length == 1 && m_arrResult[0].ErrorCode == ErrorCode.Success)
					{
						lbError.Text = "Download Complete.";	
						string strLocalFile = strPhysicalPath + "App_Data\\Temp\\" + m_arrResult[0].FTPAttachments.FileName;
						FileInfo fileInfo = new FileInfo(strLocalFile);
						long lLen = fileInfo.Length;
						Response.ContentType = "application/octet-stream";
						if (Request.UserAgent.ToLower().IndexOf("firefox") >= 0)
							Response.AddHeader("Content-Disposition", "attachment; filename=" + HttpUtility.UrlEncode(m_arrResult[0].FTPAttachments.FileName));
						else
							Response.AddHeader("Content-Disposition", "attachment; filename=" + m_arrResult[0].FTPAttachments.FileName);
						Response.AddHeader("Content-Length", lLen.ToString());
						Response.WriteFile(strLocalFile);
						try { Response.Flush(); }
						catch (Exception) { }
						Response.Close();
					}
				}
			}
			else
				lbError.Text = "Service not available.";
		}
		else
			lbError.Text = "Please enter comma separated list of Attachment ID's and versions for files to be downloaded";
	}
}
