﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using FTPAttachmentV20;
using System.Web.Configuration;

public partial class GenerateAttachmentToken : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void btnGenerate_Click(object sender, EventArgs e)
    {
        WebServiceHeader header = new WebServiceHeader();
        header.SFSessionID = Request["SFSessionID"];
        header.SFUrl = Request["SFUrl"];

        FTPAttachmentsWebService20 serviceFTPAttachment = new FTPAttachmentsWebService20();
        serviceFTPAttachment.WebServiceHeaderValue = header;
        serviceFTPAttachment.Url = WebConfigurationManager.AppSettings["FTPAttachmentV20.20"];

        FTPAttachmentV20.FTPAttachments attachment = new FTPAttachmentV20.FTPAttachments();
        attachment.Folder = txtFolder.Text;
        attachment.ServerProfile = txtProfile.Text;
        FTPAttachmentParent ftpAttachmentParent = new FTPAttachmentV20.FTPAttachmentParent();
        ftpAttachmentParent.FieldName = Request["FieldName"];
        ftpAttachmentParent.ID = Request["FieldValue"];
        attachment.Parents = new FTPAttachmentParent[] { ftpAttachmentParent };
        attachment.Version = System.Convert.ToInt32(Request["VersionID"]);
        attachment.AttachmentID = Request["ID"];

        if (String.IsNullOrEmpty(ftpAttachmentParent.FieldName))
        {
            lblAttach.Visible = false;
            lnkAttach.Visible = false;
        }
        else
        {
            lnkDelete.Visible = false;
            lblDel.Visible = false;
            lnkDownload.Visible = false;
            lblDownload.Visible = false;
        }
            

        if (ftpAttachmentParent.FieldName == "Parent__c")
            lblAttach.Text = "Attach Update Link :";
        else
            lblAttach.Text = "Attach Link :";

        TokenResult tokenResult = serviceFTPAttachment.GenerateToken(attachment);
        if (tokenResult == null || String.IsNullOrEmpty(tokenResult.Guid))
        {
            lbError.Text = "Unable to generate token";
            return;
        }
        
        lnkAttach.NavigateUrl = lnkAttach.Text = "http://localhost/sforce/ftp/Attach.aspx?token=" + tokenResult.Guid;
        lnkDelete.NavigateUrl = lnkDelete.Text = "http://localhost/sforce/ftp/Delete.aspx?token=" + tokenResult.Guid;
        lnkDownload.NavigateUrl = lnkDownload.Text = "http://localhost/sforce/ftp/Download.aspx?token=" + tokenResult.Guid;
    }
}
