using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

using FTPAttachments;

public partial class Update : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
    {
		lbError.Text = "";
    }
	
	protected void btnUpdate_Click(object sender, EventArgs e)
	{
		if (edAttachmentID.Text != "")
		{
			if (fileUpload.HasFile)
			{
				FTPAttachmentsWebService10 WebService10 = FTPService.GetServiceFromSession(Request);
				if (WebService10 != null)
				{									
					//Save Uploaded file at applications App_Data\\Temp folder.
					string strFileName, strPhysicalPath, strTempPath;
					strFileName = fileUpload.FileName;
					strPhysicalPath = Request.PhysicalApplicationPath;
					strTempPath = strPhysicalPath + "App_Data\\Temp\\";
					if (!Directory.Exists(strTempPath))
					{
						Directory.CreateDirectory(strTempPath);
					}
					String strFilePath = Request.PhysicalApplicationPath + "App_Data\\Temp\\" + strFileName;
					fileUpload.SaveAs(strFilePath);

					//Create and Fill data into array of FTPAttachments.
					string[] arrIDs = (edAttachmentID.Text).Split(',');
					FTPAttachments.FTPAttachments[] arrFTPAttachments = new FTPAttachments.FTPAttachments[arrIDs.Length];
					for (int iIndex = 0; iIndex < arrIDs.Length; iIndex++)
					{
						arrFTPAttachments[iIndex] = new FTPAttachments.FTPAttachments();
						arrFTPAttachments[iIndex].AttachmentID = arrIDs[iIndex];
						arrFTPAttachments[iIndex].Body = System.Convert.ToBase64String(File.ReadAllBytes(strFilePath));
						arrFTPAttachments[iIndex].Comment = edComment.Text;
						arrFTPAttachments[iIndex].FileName = strFileName;
						arrFTPAttachments[iIndex].IsPublic = chkIsPublic.Checked;
						arrFTPAttachments[iIndex].ServerProfile = "Default";					
					}

					//Update FTPAttachments.
					string strUploadID = Guid.NewGuid().ToString();
					WebService10.Url = WebService10.Url + "?UploadID='"+strUploadID+"'";
					Result[] m_arrResult = WebService10.UpdateAttachment(arrFTPAttachments);

					//Check the result of update.
					if (m_arrResult != null )
					{
						for (int iResult = 0; iResult < m_arrResult.Length; iResult++)
						{
							if (m_arrResult[iResult].ErrorCode == ErrorCode.Success)
								lbError.Text += m_arrResult[iResult].ErrorMsg + "<br>";
							else
								lbError.Text += "Update Failed for" + m_arrResult[iResult].FTPAttachments.FileName + " " + m_arrResult[iResult].ErrorMsg + "<br>";
						}
					}
				}
				else
					lbError.Text = "Service not available.";
			}
			else
				lbError.Text = "Select a file to upload.";
		}
		else
			lbError.Text = "Please enter comma separated list of Attachment ID's for files to be Updated";
	}
}
